-- http_support
--

call sa_make_object( 'function', 'http_encode' )
go
call sa_make_object( 'function', 'html_encode' )
go

alter function http_encode( str long varchar )
returns long varchar
begin
	-- we could encode spaces as '+' chars, or as '%20'.
	-- here we choose to encode them as '+' simply as a means of testing the server
	set str = replace( str, ' ', '+' );
	set str = replace( str, '%', '%25' );
	set str = replace( str, '!', '%21' );
	set str = replace( str, '"', '%22' );
	set str = replace( str, '&', '%26' );
	set str = replace( str, '''', '%27' );
	set str = replace( str, ',', '%2C' );
	set str = replace( str, '.', '%2E' );
	set str = replace( str, ';', '%3B' );
	return str;
end
go

alter function html_encode( str long varchar )
returns long varchar
begin
	set str = replace( str, '&', '&amp;' );
	set str = replace( str, '<', '&lt;' );
	set str = replace( str, '>', '&gt;' );
	set str = replace( str, '"', '&quot;' );
	return str;
end
go

